Index: /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90
===================================================================
--- /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 3667)
+++ /palm/trunk/SOURCE/surface_layer_fluxes_mod.f90	(revision 3668)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! Removed methods "circular" and "lookup"
+! 
+! 3655 2019-01-07 16:51:22Z knoop
 ! OpenACC port for SPEC
 ! 
@@ -228,11 +231,5 @@
 ! ------------
 !> Diagnostic computation of vertical fluxes in the constant flux layer from the
-!> values of the variables at grid point k=1. Three different methods are
-!> available:
-!> 1) the "old" version (most_method = 'circular') which is fast, but inaccurate
-!> 2) a Newton iteration method (most_method = 'newton'), which is accurate, but
-!>    slower
-!> 3) a method using a lookup table which is fast and accurate. Note, however,
-!>    that this method cannot be used in case of roughness heterogeneity
+!> values of the variables at grid point k=1 based on Newton iteration
 !>
 !> @todo (re)move large_scale_forcing actions
@@ -261,5 +258,5 @@
                intermediate_timestep_count, intermediate_timestep_count_max,   &
                land_surface, large_scale_forcing, lsf_surf, message_string,    &
-               most_method, neutral, passive_scalar, pt_surface, q_surface,    &
+               neutral, passive_scalar, pt_surface, q_surface,                 &
                run_coupled, surface_pressure, simulated_time, terminate_run,   &
                time_since_reference_point, urban_surface,                      &
@@ -400,106 +397,52 @@
 !--    First, calculate the new Obukhov length, then new friction velocity,
 !--    followed by the new scaling parameters (th*, q*, etc.), and the new
-!--    surface fluxes if required. The old routine ("circular") requires a 
-!--    different order of calls as the scaling parameters from the previous time
-!--    steps are used to calculate the Obukhov length
-
-!
-!--    Depending on setting of most_method use the "old" routine
-!--    Note, each routine is called for different surface types. 
+!--    surface fluxes if required. Note, each routine is called for different surface types. 
 !--    First call for default-type horizontal surfaces, for natural- and 
 !--    urban-type surfaces. Note, at this place only upward-facing horizontal
-!--    surfaces are treted. 
-       IF ( most_method == 'circular' )  THEN
-!
-!--       Default-type upward-facing horizontal surfaces
-          IF ( surf_def_h(0)%ns >= 1  )  THEN
-             surf => surf_def_h(0)
-             CALL calc_scaling_parameters
-             CALL calc_uvw_abs
-             IF ( .NOT. neutral )  CALL calc_ol
-             CALL calc_us
-             CALL calc_surface_fluxes
-             
-             IF ( do_output_at_2m )  THEN
-                CALL calc_pt_near_surface ( '2m' )
-             ENDIF
-          ENDIF
-!
-!--       Natural-type horizontal surfaces
-          IF ( surf_lsm_h%ns >= 1  )  THEN
-             surf => surf_lsm_h
-             CALL calc_scaling_parameters
-             CALL calc_uvw_abs
-             IF ( .NOT. neutral )  CALL calc_ol
-             CALL calc_us
-             CALL calc_surface_fluxes
-             IF ( do_output_at_2m )  THEN
-                CALL calc_pt_near_surface ( '2m' )
-             ENDIF
-          ENDIF
-!
-!--       Urban-type horizontal surfaces
-          IF ( surf_usm_h%ns >= 1  )  THEN
-             surf => surf_usm_h
-             CALL calc_scaling_parameters
-             CALL calc_uvw_abs
-             IF ( .NOT. neutral )  CALL calc_ol
-             CALL calc_us
-             CALL calc_surface_fluxes
-             IF ( do_output_at_2m )  THEN
-                CALL calc_pt_near_surface ( '2m' )
-             ENDIF
-             IF ( indoor_model )  THEN
-                CALL calc_pt_near_surface ( '10cm' )
-             ENDIF
-          ENDIF
-!
-!--    Use either Newton iteration or a lookup table for the bulk Richardson
-!--    number to calculate the Obukhov length 
-       ELSEIF ( most_method == 'newton'  .OR.  most_method == 'lookup' )  THEN
-!
-!--       Default-type upward-facing horizontal surfaces
-          IF ( surf_def_h(0)%ns >= 1  )  THEN
-             surf => surf_def_h(0)
-             CALL calc_uvw_abs
-             IF ( .NOT. neutral )  CALL calc_ol
-             CALL calc_us
-             CALL calc_scaling_parameters
-             CALL calc_surface_fluxes
-             IF ( do_output_at_2m )  THEN
-                CALL calc_pt_near_surface ( '2m' )
-             ENDIF
-          ENDIF
-!
-!--       Natural-type horizontal surfaces
-          IF ( surf_lsm_h%ns >= 1  )  THEN
-             surf => surf_lsm_h
-             CALL calc_uvw_abs
-             IF ( .NOT. neutral )  CALL calc_ol
-             CALL calc_us
-             CALL calc_scaling_parameters
-             CALL calc_surface_fluxes
-             IF ( do_output_at_2m )  THEN
-                CALL calc_pt_near_surface ( '2m' )
-             ENDIF
-          ENDIF
-!
-!--       Urban-type horizontal surfaces
-          IF ( surf_usm_h%ns >= 1  )  THEN
-             surf => surf_usm_h
-             CALL calc_uvw_abs
-             IF ( .NOT. neutral )  CALL calc_ol
-             CALL calc_us
-             CALL calc_scaling_parameters
-             CALL calc_surface_fluxes
-             IF ( do_output_at_2m )  THEN
-                CALL calc_pt_near_surface ( '2m' )
-             ENDIF
-             IF ( indoor_model )  THEN
-                CALL calc_pt_near_surface ( '10cm' )
-             ENDIF
-          ENDIF
-
+!--    surfaces are treated. 
+
+!
+!--    Default-type upward-facing horizontal surfaces
+       IF ( surf_def_h(0)%ns >= 1  )  THEN
+          surf => surf_def_h(0)
+          CALL calc_uvw_abs
+          IF ( .NOT. neutral )  CALL calc_ol
+          CALL calc_us
+          CALL calc_scaling_parameters
+          CALL calc_surface_fluxes
+          IF ( do_output_at_2m )  THEN
+             CALL calc_pt_near_surface ( '2m' )
+          ENDIF
        ENDIF
+!
+!--    Natural-type horizontal surfaces
+       IF ( surf_lsm_h%ns >= 1  )  THEN
+          surf => surf_lsm_h
+          CALL calc_uvw_abs
+          IF ( .NOT. neutral )  CALL calc_ol
+          CALL calc_us
+          CALL calc_scaling_parameters
+          CALL calc_surface_fluxes
+          IF ( do_output_at_2m )  THEN
+             CALL calc_pt_near_surface ( '2m' )
+          ENDIF
+       ENDIF
+!
+!--    Urban-type horizontal surfaces
+       IF ( surf_usm_h%ns >= 1  )  THEN
+          surf => surf_usm_h
+          CALL calc_uvw_abs
+          IF ( .NOT. neutral )  CALL calc_ol
+          CALL calc_us
+          CALL calc_scaling_parameters
+          CALL calc_surface_fluxes
+          IF ( do_output_at_2m )  THEN
+             CALL calc_pt_near_surface ( '2m' )
+          ENDIF
+          IF ( indoor_model )  THEN
+             CALL calc_pt_near_surface ( '10cm' )
+          ENDIF
+       ENDIF
+
 !
 !--    Treat downward-facing horizontal surfaces. Note, so far, these are 
@@ -549,47 +492,24 @@
 !--    flux in land-surface model in case of aero_resist_kray is not true.
        IF ( .NOT. aero_resist_kray )  THEN
-          IF ( most_method == 'circular' )  THEN
-             DO  l = 0, 1
-                IF ( surf_lsm_v(l)%ns >= 1  )  THEN
-                   surf => surf_lsm_v(l)
-!
-!--                Compute scaling parameters
-                   CALL calc_scaling_parameters
-!
-!--                Compute surface-parallel velocity
-                   CALL calc_uvw_abs_v_ugrid
-!
-!--                Compute Obukhov length
-                   IF ( .NOT. neutral )  CALL calc_ol
-!
-!--                Compute respective friction velocity on staggered grid
-                   CALL calc_us
-!
-!--                Compute respective surface fluxes for momentum and TKE
-                   CALL calc_surface_fluxes
-                ENDIF
-             ENDDO
-          ELSE
-             DO  l = 0, 1
-                IF ( surf_lsm_v(l)%ns >= 1  )  THEN
-                   surf => surf_lsm_v(l)
-!
-!--                Compute surface-parallel velocity
-                   CALL calc_uvw_abs_v_ugrid
-!
-!--                Compute Obukhov length
-                   IF ( .NOT. neutral )  CALL calc_ol
-!
-!--                Compute respective friction velocity on staggered grid
-                   CALL calc_us
-!
-!--                Compute scaling parameters
-                   CALL calc_scaling_parameters
-!
-!--                Compute respective surface fluxes for momentum and TKE
-                   CALL calc_surface_fluxes
-                ENDIF
-             ENDDO
-          ENDIF
+          DO  l = 0, 1
+             IF ( surf_lsm_v(l)%ns >= 1  )  THEN
+                surf => surf_lsm_v(l)
+!
+!--             Compute surface-parallel velocity
+                CALL calc_uvw_abs_v_ugrid
+!
+!--             Compute Obukhov length
+                IF ( .NOT. neutral )  CALL calc_ol
+!
+!--             Compute respective friction velocity on staggered grid
+                CALL calc_us
+!
+!--             Compute scaling parameters
+                CALL calc_scaling_parameters
+!
+!--             Compute respective surface fluxes for momentum and TKE
+                CALL calc_surface_fluxes
+             ENDIF
+          ENDDO
 !
 !--    No ts is required, so scaling parameters and Obukhov length do not need
@@ -652,47 +572,24 @@
 !--    flux in land-surface model in case of aero_resist_kray is not true.
        IF ( .NOT. aero_resist_kray )  THEN
-          IF ( most_method == 'circular' )  THEN
-             DO  l = 2, 3
-                IF ( surf_lsm_v(l)%ns >= 1  )  THEN
-                   surf => surf_lsm_v(l)
-!
-!--                Compute scaling parameters
-                   CALL calc_scaling_parameters
-!
-!--                Compute surface-parallel velocity
-                   CALL calc_uvw_abs_v_vgrid
-!
-!--                Compute Obukhov length
-                   IF ( .NOT. neutral )  CALL calc_ol
-!
-!--                Compute respective friction velocity on staggered grid
-                   CALL calc_us
-!
-!--                Compute respective surface fluxes for momentum and TKE
-                   CALL calc_surface_fluxes
-                ENDIF
-             ENDDO
-          ELSE
-             DO  l = 2, 3
-                IF ( surf_lsm_v(l)%ns >= 1  )  THEN
-                   surf => surf_lsm_v(l)
-!
-!--                Compute surface-parallel velocity
-                   CALL calc_uvw_abs_v_vgrid
-!
-!--                Compute Obukhov length
-                   IF ( .NOT. neutral )  CALL calc_ol
-!
-!--                Compute respective friction velocity on staggered grid
-                   CALL calc_us
-!
-!--                Compute scaling parameters
-                   CALL calc_scaling_parameters
-!
-!--                Compute respective surface fluxes for momentum and TKE
-                   CALL calc_surface_fluxes
-                ENDIF
-             ENDDO
-          ENDIF
+          DO  l = 2, 3
+             IF ( surf_lsm_v(l)%ns >= 1  )  THEN
+                surf => surf_lsm_v(l)
+!
+!--             Compute surface-parallel velocity
+                CALL calc_uvw_abs_v_vgrid
+!
+!--             Compute Obukhov length
+                IF ( .NOT. neutral )  CALL calc_ol
+!
+!--             Compute respective friction velocity on staggered grid
+                CALL calc_us
+!
+!--             Compute scaling parameters
+                CALL calc_scaling_parameters
+!
+!--             Compute respective surface fluxes for momentum and TKE
+                CALL calc_surface_fluxes
+             ENDIF
+          ENDDO
        ELSE
           DO  l = 2, 3
@@ -841,149 +738,4 @@
           IF ( surf_lsm_h%ns    >= 1 )  surf_lsm_h%ol    = 1.0E10_wp
           IF ( surf_usm_h%ns    >= 1 )  surf_usm_h%ol    = 1.0E10_wp
-       ENDIF
-
-       IF ( most_method == 'lookup' )  THEN
-
-!
-!--       Check for roughness heterogeneity. In that case terminate run and
-!--       inform user. Check for both, natural and non-natural walls.
-          IF ( surf_def_h(0)%ns >= 1 )  THEN
-             IF ( MINVAL( surf_def_h(0)%z0h ) /= MAXVAL( surf_def_h(0)%z0h )  .OR. &
-                  MINVAL( surf_def_h(0)%z0  ) /= MAXVAL( surf_def_h(0)%z0  ) )  THEN
-                terminate_run_l = .TRUE.
-             ENDIF
-          ENDIF
-          IF ( surf_lsm_h%ns >= 1 )  THEN
-             IF ( MINVAL( surf_lsm_h%z0h ) /= MAXVAL( surf_lsm_h%z0h )  .OR.       &
-                  MINVAL( surf_lsm_h%z0  ) /= MAXVAL( surf_lsm_h%z0  ) )  THEN
-                terminate_run_l = .TRUE.
-             ENDIF
-          ENDIF
-          IF ( surf_usm_h%ns >= 1 )  THEN
-             IF ( MINVAL( surf_usm_h%z0h ) /= MAXVAL( surf_usm_h%z0h )  .OR.       &
-                  MINVAL( surf_usm_h%z0  ) /= MAXVAL( surf_usm_h%z0  ) )  THEN
-                terminate_run_l = .TRUE.
-             ENDIF
-          ENDIF
-!
-!--       Check roughness homogeneity between differt surface types. 
-          IF ( surf_lsm_h%ns >= 1  .AND.  surf_def_h(0)%ns >= 1 )  THEN
-             IF ( MINVAL( surf_lsm_h%z0h ) /= MAXVAL( surf_def_h(0)%z0h )  .OR.    &
-                  MINVAL( surf_lsm_h%z0  ) /= MAXVAL( surf_def_h(0)%z0  ) )  THEN
-                terminate_run_l = .TRUE.
-             ENDIF
-          ENDIF
-          IF ( surf_usm_h%ns >= 1  .AND.  surf_def_h(0)%ns >= 1 )  THEN
-             IF ( MINVAL( surf_usm_h%z0h ) /= MAXVAL( surf_def_h(0)%z0h )  .OR.    &
-                  MINVAL( surf_usm_h%z0  ) /= MAXVAL( surf_def_h(0)%z0  ) )  THEN
-                terminate_run_l = .TRUE.
-             ENDIF
-          ENDIF
-          IF ( surf_usm_h%ns >= 1  .AND.  surf_lsm_h%ns >= 1 )  THEN
-             IF ( MINVAL( surf_usm_h%z0h ) /= MAXVAL( surf_lsm_h%z0h )  .OR.       &
-                  MINVAL( surf_usm_h%z0  ) /= MAXVAL( surf_lsm_h%z0  ) )  THEN
-                terminate_run_l = .TRUE.
-             ENDIF
-          ENDIF
-
-
-#if defined( __parallel )
-!
-!--       Make a logical OR for all processes. Force termiation of model if result
-!--       is TRUE
-          IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-          CALL MPI_ALLREDUCE( terminate_run_l, terminate_run, 1, MPI_LOGICAL,  &
-                              MPI_LOR, comm2d, ierr )
-#else
-          terminate_run = terminate_run_l
-#endif
-
-          IF ( terminate_run )  THEN
-             message_string = 'most_method = "lookup" cannot be used in ' //   &
-                              'combination with a prescribed roughness '  //   &
-                              'heterogeneity'
-             CALL message( 'surface_layer_fluxes', 'PA0116', 1, 2, 0, 6, 0 )
-          ENDIF
-
-          ALLOCATE(  zeta_tmp(0:num_steps-1) )
-
-!
-!--       Use the lowest possible value for z_mo
-          k    = nzb
-          z_mo = zu(k+1) - zw(k)
-
-!
-!--       Calculate z/L range from zeta_stretch to zeta_max using 90% of the
-!--       available steps (num_steps). The calculation is done with negative
-!--       values of zeta in order to simplify the stretching in the free
-!--       convection limit for the remaining 10% of steps.
-          zeta_tmp(0) = - zeta_max
-          num_steps_n = ( num_steps * 9 / 10 ) - 1
-          zeta_step   = (zeta_max - zeta_stretch) / REAL(num_steps_n)
-
-          DO li = 1, num_steps_n
-             zeta_tmp(li) = zeta_tmp(li-1) + zeta_step
-          ENDDO
-
-!
-!--       Calculate stretching factor for the free convection range
-          DO  WHILE ( ABS( (regr-regr_old) / regr_old ) > 1.0E-10_wp )
-             regr_old = regr
-             regr = ( 1.0_wp - ( -zeta_min / zeta_step ) * ( 1.0_wp - regr )   &
-                    )**( 10.0_wp / REAL(num_steps) )
-          ENDDO
-
-!
-!--       Calculate z/L range from zeta_min to zeta_stretch
-          DO li = num_steps_n+1, num_steps-1
-             zeta_tmp(li) = zeta_tmp(li-1) + zeta_step
-             zeta_step = zeta_step * regr
-          ENDDO
-
-!
-!--       Save roughness lengths to temporary variables
-          IF ( surf_def_h(0)%ns >= 1  )  THEN
-             z0h_min = surf_def_h(0)%z0h(1)
-             z0_min  = surf_def_h(0)%z0(1)
-          ELSEIF ( surf_lsm_h%ns >= 1 )  THEN
-             z0h_min = surf_lsm_h%z0h(1)
-             z0_min  = surf_lsm_h%z0(1)
-          ELSEIF ( surf_usm_h%ns >= 1 )  THEN
-             z0h_min = surf_usm_h%z0h(1)
-             z0_min  = surf_usm_h%z0(1)
-          ENDIF         
-!
-!--       Calculate lookup table for the Richardson number versus Obukhov length
-!--       The Richardson number (rib) is defined depending on the choice of 
-!--       boundary conditions for temperature
-          IF ( ibc_pt_b == 1 )  THEN
-             DO li = 0, num_steps-1
-                ol_tab(li)  = - z_mo / zeta_tmp(num_steps-1-li)
-                rib_tab(li) = z_mo / ol_tab(li)  / ( LOG( z_mo / z0_min )       &
-                                                - psi_m( z_mo / ol_tab(li) )    &
-                                                + psi_m( z0_min / ol_tab(li) )  &
-                                                  )**3
-             ENDDO  
-          ELSE
-             DO li = 0, num_steps-1
-                ol_tab(li)  = - z_mo / zeta_tmp(num_steps-1-li)
-                rib_tab(li) = z_mo / ol_tab(li)  * ( LOG( z_mo / z0h_min )     &
-                                              - psi_h( z_mo / ol_tab(li) )     &
-                                              + psi_h( z0h_min / ol_tab(li) )  &
-                                            )                                  &
-                                          / ( LOG( z_mo / z0_min )             &
-                                              - psi_m( z_mo / ol_tab(li) )     &
-                                              + psi_m( z0_min / ol_tab(li) )   &
-                                            )**2
-             ENDDO
-          ENDIF
-
-!
-!--       Determine minimum values of rib in the lookup table. Set upper limit 
-!--       to critical Richardson number (0.25)
-          rib_min  = MINVAL(rib_tab)
-          rib_max  = 0.25 !MAXVAL(rib_tab)
-
-          DEALLOCATE( zeta_tmp )
        ENDIF
 
@@ -1256,42 +1008,40 @@
                        ol_u      !< Upper bound of L for Newton iteration
 
-       IF ( TRIM( most_method ) /= 'circular' )  THEN
-!
-!--       Evaluate bulk Richardson number (calculation depends on
-!--       definition based on setting of boundary conditions
-          IF ( ibc_pt_b /= 1 )  THEN
-             IF ( humidity )  THEN
-                !$OMP PARALLEL DO PRIVATE( z_mo )
-                DO  m = 1, surf%ns
-
-                   z_mo = surf%z_mo(m)
-
-                   surf%rib(m) = g * z_mo                                      &
-                                 * ( surf%vpt1(m) - surf%vpt_surface(m) )      &
-                                 / ( surf%uvw_abs(m)**2 * surf%vpt1(m)         &
-                                 + 1.0E-20_wp )
-                ENDDO
-             ELSE
-                !$OMP PARALLEL DO PRIVATE( z_mo )
-                DO  m = 1, surf%ns
-
-                   z_mo = surf%z_mo(m)
-
-                   surf%rib(m) = g * z_mo                                      &
-                                 * ( surf%pt1(m) - surf%pt_surface(m) )        &
-                                 / ( surf%uvw_abs(m)**2 * surf%pt1(m)          &
-                                 + 1.0E-20_wp )
-                ENDDO
-             ENDIF
+!
+!--    Evaluate bulk Richardson number (calculation depends on
+!--    definition based on setting of boundary conditions
+       IF ( ibc_pt_b /= 1 )  THEN
+          IF ( humidity )  THEN
+             !$OMP PARALLEL DO PRIVATE( z_mo )
+             DO  m = 1, surf%ns
+
+                z_mo = surf%z_mo(m)
+
+                surf%rib(m) = g * z_mo                                         &
+                              * ( surf%vpt1(m) - surf%vpt_surface(m) )         &
+                              / ( surf%uvw_abs(m)**2 * surf%vpt1(m)            &
+                              + 1.0E-20_wp )
+             ENDDO
           ELSE
-             IF ( humidity )  THEN
-                !$OMP PARALLEL DO PRIVATE( k, z_mo )
-                DO  m = 1, surf%ns
-
-                   k   = surf%k(m)
-
-                   z_mo = surf%z_mo(m)
-
-                   surf%rib(m) = - g * z_mo * ( ( 1.0_wp + 0.61_wp             &
+             !$OMP PARALLEL DO PRIVATE( z_mo )
+             DO  m = 1, surf%ns
+
+                z_mo = surf%z_mo(m)
+
+                surf%rib(m) = g * z_mo                                         &
+                              * ( surf%pt1(m) - surf%pt_surface(m) )           &
+                              / ( surf%uvw_abs(m)**2 * surf%pt1(m) + 1.0E-20_wp )
+             ENDDO
+          ENDIF
+       ELSE
+          IF ( humidity )  THEN
+             !$OMP PARALLEL DO PRIVATE( k, z_mo )
+             DO  m = 1, surf%ns
+
+                k   = surf%k(m)
+
+                z_mo = surf%z_mo(m)
+
+                surf%rib(m) = - g * z_mo * ( ( 1.0_wp + 0.61_wp                &
                            * surf%qv1(m) ) * surf%shf(m) + 0.61_wp             &
                            * surf%pt1(m) * surf%qsws(m) ) *                    &
